# Excercises for objects and classes, part2
# Alexander Kosik
import abc

#########################
### Excercise 1 
#########################

class Car:
    """
    Write a class car with the following attributes

    Attributes:
    -----------
    type: string. Car type, e.g. "Mazda CX-5"
    hp: int. Horse power of car, e.g. 180

    Methods:
    -----------
    Create an init method initializing type and hp.
    Create an alternative constructor car_kw as classmethod with type
    and kw as parameter. 
    Hint: 1 kw => 1.36 ps, round the ps to zero decimal places

    String Representation
    ---------------------
    Create a string representation for the class:
    Type: hp
    e.g. "Mazda CX-5: 180 hp"
    """
    pass # TODO


#########################
### Excercise 2 
#########################
class Input(abc.ABC):
    """ 
    Write an abstract base class Input with two abstract methods:
    - read()
    - content()
    """
    # TODO
    def read(source):
        """ 
        Reads the complete input from source and stores in internal structure
        """
        pass 

    # TODO
    def content():
        """ 
        Returns an iterator delivering the stored content
        """
        pass 


# TODO
class FileInput(Input):
    """ 
    Implement the abstract methods for file input
    read()::
    the: whole content of file.
    Pass the file (or file-like-object) as first parameter

    content():
    delivers an iterator returning the content by line
    """

class ListInput(Input):
    """ 
    Implement the abstract methods for List input
    read(): reads the whole content of list
    content(): delivers an iterator returning the content by list entries
    """